Index: /NEMO/releases/release-4.0-HEAD/INSTALL.rst
===================================================================
--- /NEMO/releases/release-4.0-HEAD/INSTALL.rst	(revision 12388)
+++ /NEMO/releases/release-4.0-HEAD/INSTALL.rst	(revision 12389)
@@ -122,5 +122,5 @@
 .. code:: console
 
-   $ svn co https://forge.ipsl.jussieu.fr/nemo/svn/NEMO/trunk
+   $ svn co https://forge.ipsl.jussieu.fr/nemo/svn/NEMO/releases/release-4.0.2
 
 Description of 1\ :sup:`st` level tree structure
Index: /NEMO/releases/release-4.0-HEAD/doc/latex/global/document.tex
===================================================================
--- /NEMO/releases/release-4.0-HEAD/doc/latex/global/document.tex	(revision 12388)
+++ /NEMO/releases/release-4.0-HEAD/doc/latex/global/document.tex	(revision 12389)
@@ -5,5 +5,5 @@
 
 %% NEMO release version
-\def \version{trunk}
+\def \version{4.0.2}
 
 %% Preamble
Index: /NEMO/releases/release-4.0-HEAD/doc/latex/global/frontpage.tex
===================================================================
--- /NEMO/releases/release-4.0-HEAD/doc/latex/global/frontpage.tex	(revision 12388)
+++ /NEMO/releases/release-4.0-HEAD/doc/latex/global/frontpage.tex	(revision 12389)
@@ -32,6 +32,6 @@
   \begin{center}
     \LARGE Version \version\ -\ \today \\
-    \medskip
-    \href{http://doi.org/10.5281/zenodo.\zid}{ \includegraphics{badges/zenodo.\zid} }
+%    \medskip
+%    \href{http://doi.org/10.5281/zenodo.\zid}{ \includegraphics{badges/zenodo.\zid} }
   \end{center}
 
Index: /NEMO/releases/release-4.0-HEAD/doc/latex/global/packages.tex
===================================================================
--- /NEMO/releases/release-4.0-HEAD/doc/latex/global/packages.tex	(revision 12388)
+++ /NEMO/releases/release-4.0-HEAD/doc/latex/global/packages.tex	(revision 12389)
@@ -9,5 +9,5 @@
 
 %% customization (layout, header/footer styles & contents, background)
-\usepackage{draftwatermark}
+%\usepackage{draftwatermark}
 \usepackage[margin = 2cm]{geometry}
 \usepackage[pages = some]{background}   %% 'some' for title page
Index: /NEMO/releases/release-4.0-HEAD/doc/rst/source/conf.py
===================================================================
--- /NEMO/releases/release-4.0-HEAD/doc/rst/source/conf.py	(revision 12388)
+++ /NEMO/releases/release-4.0-HEAD/doc/rst/source/conf.py	(revision 12389)
@@ -50,7 +50,7 @@
 #
 # The short X.Y version.
-version = 'trk'
+version = '4.0'
 # The full version, including alpha/beta/rc tags.
-release = 'trunk'
+release = '4.0.2'
 
 # The language for content autogenerated by Sphinx. Refer to documentation
Index: /NEMO/releases/release-4.0.2/INSTALL.rst
===================================================================
--- /NEMO/releases/release-4.0.2/INSTALL.rst	(revision 12388)
+++ /NEMO/releases/release-4.0.2/INSTALL.rst	(revision 12389)
@@ -122,5 +122,5 @@
 .. code:: console
 
-   $ svn co https://forge.ipsl.jussieu.fr/nemo/svn/NEMO/trunk
+   $ svn co https://forge.ipsl.jussieu.fr/nemo/svn/NEMO/releases/release-4.0.2
 
 Description of 1\ :sup:`st` level tree structure
Index: /NEMO/releases/release-4.0.2/doc/latex/global/document.tex
===================================================================
--- /NEMO/releases/release-4.0.2/doc/latex/global/document.tex	(revision 12388)
+++ /NEMO/releases/release-4.0.2/doc/latex/global/document.tex	(revision 12389)
@@ -5,5 +5,5 @@
 
 %% NEMO release version
-\def \version{trunk}
+\def \version{4.0.2}
 
 %% Preamble
Index: /NEMO/releases/release-4.0.2/doc/latex/global/frontpage.tex
===================================================================
--- /NEMO/releases/release-4.0.2/doc/latex/global/frontpage.tex	(revision 12388)
+++ /NEMO/releases/release-4.0.2/doc/latex/global/frontpage.tex	(revision 12389)
@@ -32,6 +32,6 @@
   \begin{center}
     \LARGE Version \version\ -\ \today \\
-    \medskip
-    \href{http://doi.org/10.5281/zenodo.\zid}{ \includegraphics{badges/zenodo.\zid} }
+%    \medskip
+%    \href{http://doi.org/10.5281/zenodo.\zid}{ \includegraphics{badges/zenodo.\zid} }
   \end{center}
 
Index: /NEMO/releases/release-4.0.2/doc/latex/global/packages.tex
===================================================================
--- /NEMO/releases/release-4.0.2/doc/latex/global/packages.tex	(revision 12388)
+++ /NEMO/releases/release-4.0.2/doc/latex/global/packages.tex	(revision 12389)
@@ -9,5 +9,5 @@
 
 %% customization (layout, header/footer styles & contents, background)
-\usepackage{draftwatermark}
+%\usepackage{draftwatermark}
 \usepackage[margin = 2cm]{geometry}
 \usepackage[pages = some]{background}   %% 'some' for title page
Index: /NEMO/releases/release-4.0.2/doc/rst/source/conf.py
===================================================================
--- /NEMO/releases/release-4.0.2/doc/rst/source/conf.py	(revision 12388)
+++ /NEMO/releases/release-4.0.2/doc/rst/source/conf.py	(revision 12389)
@@ -50,7 +50,7 @@
 #
 # The short X.Y version.
-version = 'trk'
+version = '4.0'
 # The full version, including alpha/beta/rc tags.
-release = 'trunk'
+release = '4.0.2'
 
 # The language for content autogenerated by Sphinx. Refer to documentation