Index: ils/CI/sette_top_pisces_lbc/BATCH_TEMPLATE/batch-openmpi_NAVITI_MERCATOR
===================================================================
--- /utils/CI/sette_top_pisces_lbc/BATCH_TEMPLATE/batch-openmpi_NAVITI_MERCATOR	(revision 12425)
+++ 	(revision )
@@ -1,75 +1,0 @@
-#!/bin/bash 
-#!
-#PBS -N sette
-#PBS -e sette.$PBS_JOBID.err
-#PBS -o sette.$PBS_JOBID.out
-#PBS -l nodes=NODES:ppn=NPROC_NODE
-#PBS -q QUEUE
-#PBS -l walltime=03:00:00
-#PBS -l pmem=3gb
-
-#
-# Test specific settings. Do not hand edit these lines; the fcm_job.sh script will set these
-# (via sed operating on this template job file). 
-#
-  OCEANCORES=NPROCS
-  export SETTE_DIR=DEF_SETTE_DIR
-
-###############################################################
-#
-# set up mpp computing environment
-#
-# Local settings for machine IBM Power6 (VARGAS at IDRIS France)
-#
-#cbr export MPIRUN="mpiexec -n $OCEANCORES"
-export MPIRUN="mpirun -np $OCEANCORES"
-
-#
-# load sette functions (only post_test_tidyup needed)
-#
-  . ${SETTE_DIR}/all_functions.sh
-#
-
-# Don't remove neither change the following line
-# BODY
-
-#
-# These variables are needed by post_test_tidyup function in all_functions.sh
-#
-  export EXE_DIR=DEF_EXE_DIR
-  export INPUT_DIR=DEF_INPUT_DIR
-  export CONFIG_DIR=DEF_CONFIG_DIR
-  export TOOLS_DIR=DEF_TOOLS_DIR
-  export NEMO_VALIDATION_DIR=DEF_NEMO_VALIDATION
-  export NEW_CONF=DEF_NEW_CONF
-  export CMP_NAM=DEF_CMP_NAM
-  export TEST_NAME=DEF_TEST_NAME
-#
-# end of set up
-###############################################################
-#
-# change to the working directory 
-#
-cd ${EXE_DIR}
-  echo Running on host `hostname`
-  echo Time is `date`
-  echo Directory is `pwd`
-# 
-#  Run the parallel MPI executable 
-#
-  echo "Running time ${MPIRUN} ./nemo"
-#
-  if [ MPI_FLAG == "yes" ]; then
-     mpirun -np $OCEANCORES ./nemo
-  else
-     time ./nemo
-  fi
-
-#
-  post_test_tidyup
-
-# END_BODY
-# Don't remove neither change the previous line
-
-
-  exit
Index: /utils/CI/sette_top_pisces_lbc/prepare_job.sh
===================================================================
--- /utils/CI/sette_top_pisces_lbc/prepare_job.sh	(revision 12425)
+++ /utils/CI/sette_top_pisces_lbc/prepare_job.sh	(revision 12426)
@@ -254,30 +254,7 @@
                                 export GROUP_IDRIS=`echo ${USER} |cut -c 2-4`
                                 ;;
-                        openmpi_NAVITI_MERCATOR)
-                                echo NB_PROCS ${NB_PROC}
-                                echo NB_NODES ${NB_NODES}
-                                echo  NB_PROC ${NB_PROC}
-                                if [ ${NB_PROC} -eq 1 ] ; then
-                                   NB_NODES=1
-                                   QUEUE=monoproc
-                                   NB_PROC_NODE=${NB_PROC}
-                                else
-                                   if [ ${NB_PROC} -le 16 ] ; then
-                                      NB_NODES=1
-                                      QUEUE=mono
-                                      NB_PROC_NODE=${NB_PROC}
-                                   else
-                                      NB_NODES=$( echo $NB_PROC | awk '{print $1 - $1 % 16}'  | awk '{print $1 / 16 }')
-                                      QUEUE=multi
-                                      NB_PROC_NODE=16
-                                  fi
-                                fi
-                                echo NB_PROCS     ${NB_PROC}
-                                echo NB_NODES     ${NB_NODES}
-                                echo NB_PROC_NODE ${NB_PROC_NODE}
-                                ;;
                         openmpi_KARA_MERCATOR_XIOS)
                                 NB_NODES=$( echo $NB_PROC | awk '{print $1 - $1 % 32}'  | awk '{print $1 / 32 }')
-                                NB_PROC_NODE=16
+                                NB_PROC_NODE=32
 
                                 if [ ${NB_PROC} -le 128 ] ; then
@@ -311,9 +288,4 @@
 
         case ${COMPILER} in
-              openmpi_NAVITI_MERCATOR )
-                    cat run_sette_test.job | sed -e"s/NPROC_NODE/${NB_PROC_NODE}/" \
-                                                 -e"s:QUEUE:${QUEUE}:" > run_sette_test1.job
-                    mv run_sette_test1.job run_sette_test.job
-                    ;;
               openmpi_KARA_MERCATOR_XIOS )
                     cat run_sette_test.job | sed -e"s/NPROC_NODE/${NB_PROC_NODE}/" \